<template>
    <div>
        <div class="d-flex justify-content-between">
            <div>
                <h1 class="h3 mb-4 text-gray-800">Leave</h1>
            </div>
            <div>
                <router-link
                    :to="{ name: 'LeaveCreate' }"
                    class="btn btn-success"
                    role="button"
                    >Leave Request</router-link
                >
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <search-box
                    @input="getObjects"
                    delay="500"
                    ref="searchBox"
                ></search-box>
            </div>
        </div>

        <leave-card
            v-for="object in dataObjects"
            :key="object.id"
            :object="object"
            :disabled="!isAdmin"
            @delete="onDeleted"
        >
        </leave-card>

        <div v-if="dataObjects.length == 0" class="card text-black shadow">
            <div class="card-body">
                No Leave List
                <div class="text-black-50 small">
                    please request new leave
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import SearchBox from "../../components/SearchBoxComponent";
import LeaveCard from "../../components/leave/LeaveCardComponent";
export default {
    components: {
        SearchBox,
        LeaveCard
    },
    data() {
        return {
            dataObjects: [],
            isAdmin: this.$isAdmin=="1",
        };
    },
    created() {
        this.prepare();
    },
    mounted() {
        this.$refs.searchBox.$refs.searchBox.focus();
    },
    methods: {
        prepare() {
            this.getObjects();
        },
        getObjects(search = "") {
            axios
                .get("/api/leave/all", {
                    params: {
                        limit: 10,
                        search: search
                    }
                })
                .then(res => {
                    this.dataObjects = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        onDeleted() {
            this.$refs.searchBox.$refs.searchBox.focus();
            this.getObjects();
        }
    }
};
</script>
